The component WebElement for oj-tag-cloud. Do not instantiate this class directly, instead, use ojTagCloud.

### Hierarchy

- OjTagCloudBase
  - OjTagCloud

## Index

### Constructors

- constructor

### Methods

- changeHiddenCategories
- changeHighlightedCategories
- changeSelection
- clear
- click
- findElement
- findElements
- getAnimationOnDataChange
- getAnimationOnDisplay
- getAs
- getAttribute
- getCssValue
- getDriver
- getHiddenCategories
- getHighlightMatch
- getHighlightedCategories
- getHoverBehavior
- getId
- getItems
- getLayout
- getLocation
- getProperty
- getRect
- getSelection
- getSelectionMode
- getShadowRoot
- getSize
- getStyleDefaults
- getTagName
- getText
- getTooltip
- getTouchResponse
- getTrackResize
- getTranslations
- hasSize
- hasVisibility
- isDisplayed
- isEnabled
- isSelected
- sendKeys
- serialize
- setProperty
- submit
- takeScreenshot
- whenBusyContextReady
- whenReady
- buildId
- equals
- extractId
- isId

## Constructors

### constructor

- new OjTagCloud(el: WebElement, locators: ElementLocators): OjTagCloud

- Inherited from OjTagCloudBase.constructor

  Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjTagCloud

## Methods

### changeHiddenCategories

- changeHiddenCategories(hiddenCategories: string[]): Promise<void>

- Inherited from OjTagCloudBase.changeHiddenCategories

  Sets the value of `hiddenCategories` property. An array of category strings used for category filtering. Data items with a category in hiddenCategories will be filtered.

  #### Parameters

  - ##### hiddenCategories: string[]

    The value to set for `hiddenCategories`

  #### Returns Promise<void>

### changeHighlightedCategories

- changeHighlightedCategories(highlightedCategories: string[]): Promise<void>

- Inherited from OjTagCloudBase.changeHighlightedCategories

  Sets the value of `highlightedCategories` property. An array of category strings used for highlighting. Data items matching categories in this array will be highlighted.

  #### Parameters

  - ##### highlightedCategories: string[]

    The value to set for `highlightedCategories`

  #### Returns Promise<void>

### changeSelection

- changeSelection(selection: any[]): Promise<void>

- Inherited from OjTagCloudBase.changeSelection

  Sets the value of `selection` property. An array containing the ids of the initially selected data items.

  #### Parameters

  - ##### selection: any[]

    The value to set for `selection`

  #### Returns Promise<void>

### clear

- clear(): Promise<void>

- Inherited from OjTagCloudBase.clear

  Schedules a command to clear the `value` of this element. This command has no effect if the underlying DOM element is neither a text INPUT element nor a TEXTAREA element.

  #### Returns Promise<void>

  A promise that will be resolved when the element has been cleared.

### click

- click(): Promise<void>

- Inherited from OjTagCloudBase.click

  Schedules a command to click on this element.

  #### Returns Promise<void>

  A promise that will be resolved when the click command has completed.

### findElement

- findElement(locator: Locator): WebElementPromise

- Inherited from OjTagCloudBase.findElement

  Schedule a command to find a descendant of this element. If the element cannot be found, a {@link bot.ErrorCode.NO_SUCH_ELEMENT} result will be returned by the driver. Unlike other commands, this error cannot be suppressed. In other words, scheduling a command to find an element doubles as an assert that the element is present on the page. To test whether an element is present on the page, use {@link #findElements}.

  The search criteria for an element may be defined using one of the factories in the By namespace, or as a short-hand {@link By.Hash} object. For example, the following two statements are equivalent:

      var e1 = element.findElement(By.id('foo'));
      var e2 = element.findElement({id:'foo'});

  You may also provide a custom locator function, which takes as input this WebDriver instance and returns a WebElement, or a promise that will resolve to a WebElement. For example, to find the first visible link on a page, you could write:

      var link = element.findElement(firstVisibleLink);

      function firstVisibleLink(element) {
        var links = element.findElements(By.tagName('a'));
        return promise.filter(links, function(link) {
          return links.isDisplayed();
        }).then(function(visibleLinks) {
          return visibleLinks[0];
        });
      }

  #### Parameters

  - ##### locator: Locator

    The locator strategy to use when searching for the element.

  #### Returns WebElementPromise

  A WebElement that can be used to issue commands against the located element. If the element is not found, the element will be invalidated and all scheduled commands aborted.

### findElements

- findElements(locator: Locator): Promise<WebElement[]>

- Inherited from OjTagCloudBase.findElements

  Schedules a command to find all of the descendants of this element that match the given search criteria.

  #### Parameters

  - ##### locator: Locator

    The locator strategy to use when searching for the element.

  #### Returns Promise<WebElement[]>

  A promise that will resolve to an array of WebElements.

### getAnimationOnDataChange

- getAnimationOnDataChange(): Promise<string>

- Inherited from OjTagCloudBase.getAnimationOnDataChange

  Gets the value of `animationOnDataChange` property. Specifies the animation that is applied on data changes.

  #### Returns Promise<string>

  The value of `animationOnDataChange` property.

### getAnimationOnDisplay

- getAnimationOnDisplay(): Promise<string>

- Inherited from OjTagCloudBase.getAnimationOnDisplay

  Gets the value of `animationOnDisplay` property. Specifies the animation that is shown on initial display.

  #### Returns Promise<string>

  The value of `animationOnDisplay` property.

### getAs

- getAs(): Promise<string>

- Inherited from OjTagCloudBase.getAs

  Gets the value of `as` property. An alias for the '$current' context variable passed to slot content for the itemTemplate slot.

  deprecated

    Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

  #### Returns Promise<string>

  The value of `as` property.

### getAttribute

- getAttribute(attributeName: string): Promise<string>

- Inherited from OjTagCloudBase.getAttribute

  Schedules a command to query for the value of the given attribute of the element. Will return the current value, even if it has been modified after the page has been loaded. More exactly, this method will return the value of the given attribute, unless that attribute is not present, in which case the value of the property with the same name is returned. If neither value is set, null is returned (for example, the 'value' property of a textarea element). The 'style' attribute is converted as best can be to a text representation with a trailing semi-colon. The following are deemed to be 'boolean' attributes and will return either 'true' or null:

  async, autofocus, autoplay, checked, compact, complete, controls, declare, defaultchecked, defaultselected, defer, disabled, draggable, ended, formnovalidate, hidden, indeterminate, iscontenteditable, ismap, itemscope, loop, multiple, muted, nohref, noresize, noshade, novalidate, nowrap, open, paused, pubdate, readonly, required, reversed, scoped, seamless, seeking, selected, spellcheck, truespeed, willvalidate

  Finally, the following commonly mis-capitalized attribute/property names are evaluated as expected:

  - 'class'
  - 'readonly'

  #### Parameters

  - ##### attributeName: string

    The name of the attribute to query.

  #### Returns Promise<string>

  A promise that will be resolved with the attribute's value. The returned value will always be either a string or null.

### getCssValue

- getCssValue(cssStyleProperty: string): Promise<string>

- Inherited from OjTagCloudBase.getCssValue

  Schedules a command to query for the computed style of the element represented by this instance. If the element inherits the named style from its parent, the parent will be queried for its value. Where possible, color values will be converted to their hex representation (e.g. #00ff00 instead of rgb(0, 255, 0)).

  Warning: the value returned will be as the browser interprets it, so it may be tricky to form a proper assertion.

  #### Parameters

  - ##### cssStyleProperty: string

    The name of the CSS style property to look up.

  #### Returns Promise<string>

  A promise that will be resolved with the requested CSS value.

### getDriver

- getDriver(): WebDriver

- Inherited from OjTagCloudBase.getDriver

  #### Returns WebDriver

  The parent driver for this instance.

### getHiddenCategories

- getHiddenCategories(): Promise<string[]>

- Inherited from OjTagCloudBase.getHiddenCategories

  Gets the value of `hiddenCategories` property. An array of category strings used for category filtering. Data items with a category in hiddenCategories will be filtered.

  #### Returns Promise<string[]>

  The value of `hiddenCategories` property.

### getHighlightMatch

- getHighlightMatch(): Promise<string>

- Inherited from OjTagCloudBase.getHighlightMatch

  Gets the value of `highlightMatch` property. The matching condition for the highlightedCategories property. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `highlightMatch` property.

### getHighlightedCategories

- getHighlightedCategories(): Promise<string[]>

- Inherited from OjTagCloudBase.getHighlightedCategories

  Gets the value of `highlightedCategories` property. An array of category strings used for highlighting. Data items matching categories in this array will be highlighted.

  #### Returns Promise<string[]>

  The value of `highlightedCategories` property.

### getHoverBehavior

- getHoverBehavior(): Promise<string>

- Inherited from OjTagCloudBase.getHoverBehavior

  Gets the value of `hoverBehavior` property. Defines the behavior applied when hovering over data items.

  #### Returns Promise<string>

  The value of `hoverBehavior` property.

### getId

- getId(): Promise<string>

- Inherited from OjTagCloudBase.getId

  #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

### getItems

- getItems(): Promise<<internal>.Items[]>

- Inherited from OjTagCloudBase.getItems

  Gets the value of `items` property. An array of objects defining the data items for the tag cloud items. Also accepts a Promise for deferred data rendering.

  #### Returns Promise<<internal>.Items[]>

  The value of `items` property.

### getLayout

- getLayout(): Promise<string>

- Inherited from OjTagCloudBase.getLayout

  Gets the value of `layout` property. The layout to use for tag display.

  #### Returns Promise<string>

  The value of `layout` property.

### getLocation

- getLocation(): Promise<ILocation>

- Inherited from OjTagCloudBase.getLocation

  DEPRECATED 3.0 Schedules a command to compute the location of this element in page space.

  #### Returns Promise<ILocation>

  > } A promise that will be resolved to the element's location as a {@code {x:number, y:number}} object.

### getProperty

- getProperty<T>(propertyName: string): Promise<T>

- Inherited from OjTagCloudBase.getProperty

  Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

### getRect

- getRect(): Promise<IRectangle>

- Inherited from OjTagCloudBase.getRect

  Returns an object describing an element's location, in pixels relative to the document element, and the element's size in pixels.

  #### Returns Promise<IRectangle>

### getSelection

- getSelection(): Promise<any[]>

- Inherited from OjTagCloudBase.getSelection

  Gets the value of `selection` property. An array containing the ids of the initially selected data items.

  #### Returns Promise<any[]>

  The value of `selection` property.

### getSelectionMode

- getSelectionMode(): Promise<string>

- Inherited from OjTagCloudBase.getSelectionMode

  Gets the value of `selectionMode` property. Specifies the selection mode.

  #### Returns Promise<string>

  The value of `selectionMode` property.

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Inherited from OjTagCloudBase.getShadowRoot

  Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with {@link NoSuchShadowRootError}

### getSize

- getSize(): Promise<ISize>

- Inherited from OjTagCloudBase.getSize

  DEPRECATED 3.0 Schedules a command to compute the size of this element's bounding box, in pixels.

  #### Returns Promise<ISize>

  > } A promise that will be resolved with the element's size as a {@code {width:number, height:number}} object.

### getStyleDefaults

- getStyleDefaults(): Promise<<internal>.StyleDefaults>

- Inherited from OjTagCloudBase.getStyleDefaults

  Gets the value of `styleDefaults` property. An object defining the style defaults for this tag cloud.

  #### Returns Promise<<internal>.StyleDefaults>

  The value of `styleDefaults` property.

### getTagName

- getTagName(): Promise<string>

- Inherited from OjTagCloudBase.getTagName

  Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

### getText

- getText(): Promise<string>

- Inherited from OjTagCloudBase.getText

  Get the visible (i.e. not hidden by CSS) innerText of this element, including sub-elements, without any leading or trailing whitespace.

  #### Returns Promise<string>

  A promise that will be resolved with the element's visible text.

### getTooltip

- getTooltip(): Promise<<internal>.Tooltip>

- Inherited from OjTagCloudBase.getTooltip

  Gets the value of `tooltip` property. An object containing an optional callback function for tooltip customization.

  #### Returns Promise<<internal>.Tooltip>

  The value of `tooltip` property.

### getTouchResponse

- getTouchResponse(): Promise<string>

- Inherited from OjTagCloudBase.getTouchResponse

  Gets the value of `touchResponse` property. Specifies configuration options for touch and hold delays on mobile devices. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `touchResponse` property.

### getTrackResize

- getTrackResize(): Promise<string>

- Inherited from OjTagCloudBase.getTrackResize

  Gets the value of `trackResize` property. Defines whether the element will automatically render in response to changes in size. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `trackResize` property.

### getTranslations

- getTranslations(): Promise<<internal>.Translations>

- Inherited from OjTagCloudBase.getTranslations

  Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<<internal>.Translations>

  The value of `translations` property.

### Protected hasSize

- hasSize(): Condition<Promise<boolean>>

- Inherited from OjTagCloudBase.hasSize

  Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  deprecated

    Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

### Protected hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Inherited from OjTagCloudBase.hasVisibility

  Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by {@link #isDisplayed}, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  deprecated

  #### Returns Condition<Promise<boolean>>

### isDisplayed

- isDisplayed(): Promise<boolean>

- Inherited from OjTagCloudBase.isDisplayed

  Schedules a command to test whether this element is currently displayed.

  #### Returns Promise<boolean>

  A promise that will be resolved with whether this element is currently visible on the page.

### isEnabled

- isEnabled(): Promise<boolean>

- Inherited from OjTagCloudBase.isEnabled

  Schedules a command to query whether the DOM element represented by this instance is enabled, as dicted by the {@code disabled} attribute.

  #### Returns Promise<boolean>

  A promise that will be resolved with whether this element is currently enabled.

### isSelected

- isSelected(): Promise<boolean>

- Inherited from OjTagCloudBase.isSelected

  Schedules a command to query whether this element is selected.

  #### Returns Promise<boolean>

  A promise that will be resolved with whether this element is currently selected.

### sendKeys

- sendKeys(...varArgs: (string | number | Promise<string | number>)[]): Promise<void>

- Inherited from OjTagCloudBase.sendKeys

  Schedules a command to type a sequence on the DOM element represented by this promsieinstance.

  Modifier keys (SHIFT, CONTROL, ALT, META) are stateful; once a modifier is processed in the keysequence, that key state is toggled until one of the following occurs:

  - The modifier key is encountered again in the sequence. At this point the state of the key is toggled (along with the appropriate keyup/down events).

  - The {@link Key.NULL} key is encountered in the sequence. When this key is encountered, all modifier keys current in the down state are released (with accompanying keyup events). The NULL key can be used to simulate common keyboard shortcuts:

          element.sendKeys('text was',
                           Key.CONTROL, 'a', Key.NULL,
                           'now text is');
          // Alternatively:
          element.sendKeys('text was',
                           Key.chord(Key.CONTROL, 'a'),
                           'now text is');

  - The end of the keysequence is encountered. When there are no more keys to type, all depressed modifier keys are released (with accompanying keyup events).

  If this element is a file input ({@code }), the specified key sequence should specify the path to the file to attach to the element. This is analgous to the user clicking 'Browse...' and entering the path into the file select dialog.

      var form = driver.findElement(By.css('form'));
      var element = form.findElement(By.css('input[type=file]'));
      element.sendKeys('/path/to/file.txt');
      form.submit();

  For uploads to function correctly, the entered path must reference a file on the browser's machine, not the local machine running this script. When running against a remote Selenium server, a FileDetector may be used to transparently copy files to the remote machine before attempting to upload them in the browser.

  Note: On browsers where native keyboard events are not supported (e.g. Firefox on OS X), key events will be synthesized. Special punctionation keys will be synthesized according to a standard QWERTY en-us keyboard layout.

  #### Parameters

  - ##### Rest ...varArgs: (string | number | Promise<string | number>)[]

    The sequence of keys to type. All arguments will be joined into a single sequence.

  #### Returns Promise<void>

  A promise that will be resolved when all keys have been typed.

### serialize

- serialize(): Promise<IWebElementId>

- Inherited from OjTagCloudBase.serialize

  override

  #### Returns Promise<IWebElementId>

### Protected setProperty

- setProperty<T>(propertyName: string, value: T): Promise<void>

- Inherited from OjTagCloudBase.setProperty

  Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

### submit

- submit(): Promise<void>

- Inherited from OjTagCloudBase.submit

  Schedules a command to submit the form containing this element (or this element if it is a FORM element). This command is a no-op if the element is not contained in a form.

  #### Returns Promise<void>

  A promise that will be resolved when the form has been submitted.

### takeScreenshot

- takeScreenshot(optScroll?: boolean): Promise<string>

- Inherited from OjTagCloudBase.takeScreenshot

  Take a screenshot of the visible region encompassed by this element's bounding rectangle.

  #### Parameters

  - ##### Optional optScroll: boolean

    Optional argument that indicates whether the element should be scrolled into view before taking a screenshot. Defaults to false.

  #### Returns Promise<string>

  A promise that will be resolved to the screenshot as a base-64 encoded PNG.

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Inherited from OjTagCloudBase.whenBusyContextReady

  Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with {@link #whenReady}. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

### whenReady

- whenReady(): Promise<void>

- Inherited from OjTagCloudBase.whenReady

  Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

### Static buildId

- buildId(id: string, opt_noLegacy?: boolean): IWebElementId

- Inherited from OjTagCloudBase.buildId

  #### Parameters

  - ##### id: string

    The raw ID.

  - ##### Optional opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

### Static equals

- equals(a: WebElement, b: WebElement): Promise<boolean>

- Inherited from OjTagCloudBase.equals

  Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

### Static extractId

- extractId(obj: IWebElementId): string

- Inherited from OjTagCloudBase.extractId

  Extracts the encoded WebElement ID from the object.

  throws

    {TypeError} if the object is not a valid encoded ID.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

### Static isId

- isId(obj: IWebElementId): boolean

- Inherited from OjTagCloudBase.isId

  #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

Generated using TypeDoc